#[doc = "Register `MACRO_0_FREE_SFLASH991` reader"]
pub struct R(crate::R<MACRO_0_FREE_SFLASH991_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<MACRO_0_FREE_SFLASH991_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<MACRO_0_FREE_SFLASH991_SPEC>> for R {
    fn from(reader: crate::R<MACRO_0_FREE_SFLASH991_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `MACRO_0_FREE_SFLASH991` writer"]
pub struct W(crate::W<MACRO_0_FREE_SFLASH991_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<MACRO_0_FREE_SFLASH991_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<MACRO_0_FREE_SFLASH991_SPEC>> for W {
    fn from(writer: crate::W<MACRO_0_FREE_SFLASH991_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `BYTE_MEM` reader - Uncommited storage byte in Supervisory Flash"]
pub struct BYTE_MEM_R(crate::FieldReader<u8, u8>);
impl BYTE_MEM_R {
    pub(crate) fn new(bits: u8) -> Self {
        BYTE_MEM_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for BYTE_MEM_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `BYTE_MEM` writer - Uncommited storage byte in Supervisory Flash"]
pub struct BYTE_MEM_W<'a> {
    w: &'a mut W,
}
impl<'a> BYTE_MEM_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xff) | (value as u8 & 0xff);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:7 - Uncommited storage byte in Supervisory Flash"]
    #[inline(always)]
    pub fn byte_mem(&self) -> BYTE_MEM_R {
        BYTE_MEM_R::new((self.bits & 0xff) as u8)
    }
}
impl W {
    #[doc = "Bits 0:7 - Uncommited storage byte in Supervisory Flash"]
    #[inline(always)]
    pub fn byte_mem(&mut self) -> BYTE_MEM_W {
        BYTE_MEM_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Uncommitted Supervisorly Flash in Macro 0\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [macro_0_free_sflash991](index.html) module"]
pub struct MACRO_0_FREE_SFLASH991_SPEC;
impl crate::RegisterSpec for MACRO_0_FREE_SFLASH991_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [macro_0_free_sflash991::R](R) reader structure"]
impl crate::Readable for MACRO_0_FREE_SFLASH991_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [macro_0_free_sflash991::W](W) writer structure"]
impl crate::Writable for MACRO_0_FREE_SFLASH991_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets MACRO_0_FREE_SFLASH991 to value 0"]
impl crate::Resettable for MACRO_0_FREE_SFLASH991_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
